<?
//    -------------------------------------------------------------------------
//    $Id: Array_Manip.php,v 1.2 2002/12/11 00:22:23 joko Exp $
//    -------------------------------------------------------------------------
//    $Log: Array_Manip.php,v $
//    Revision 1.2  2002/12/11 00:22:23  joko
//    +  function getModified()
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


// ------------------------------------------------------------------
// takes a string and searches values of haystack to remove this in place
// returns "true" if operation succeeded
function removeNeedle($needle, &$haystack) {
  $arrpos = array_search($needle, $haystack);
  if (is_numeric($arrpos)) {
    array_splice($haystack, $arrpos, 1);
    return true;
  }
  return false;
}

// ------------------------------------------------------------------
// removes single or multiple elements from haystack
// takes a string or an array containing scalars
// matching the to-be-removed values
function removeNeedles($needle, &$haystack) {
  $res = true;
  if (is_array($needle)) {
    foreach ($needle as $val) {
      $res &= removeNeedle($val, $haystack);
    }
  } else {
    $res &= removeNeedle($needle, $haystack);
  }
  return $res;
}


  function prefixElements_walker(&$item, $key, $prefix) {
    $item = $prefix . $item;
  }


class Array_Manip {

  var $haystack;

  function Array_Manip(&$haystack, $args = array()) {
    $this->haystack = $haystack;
  }
  
  function getModified() {
    return $this->haystack;
  }

  function remove($needle, $level) {
    $res = $this->_rm_needle_bylevel($needle, $level);
    return $res;
  }

  // ------------------------------------------------------------------
  // removes single or multiple elements from haystack
  // takes an additional argument: the nesting level inside haystack to operate on
  function _rm_needle_bylevel($needle, $level) {
    global $cLevel, $tLevel, $array_walk_found;
    $res = true;
  
    $array_walk_found = false;
    $cLevel = 0;
    $tLevel = $level;
  
    if (!is_array($this->haystack)) { return; }
    
    array_walk($this->haystack, array($this, '_rm_needle_bylevel_walker'), $needle);
    return $array_walk_found;
  }

  // walker function for removing needles by level
  function _rm_needle_bylevel_walker(&$item, $key, $arg_needle) {
    global $cLevel, $tLevel, $array_walk_found;
    $cLevel++;
    if (is_array($item)) {
      if ($cLevel == $tLevel) {
        $array_walk_found |= removeNeedles($arg_needle, $item);
        //$array_walk_found |= $this->_rm_needle_multi($arg_needle);
      } else {
        array_walk($item, array($this, '_rm_needle_bylevel_walker'), $arg_needle);
      }
    } else {
    }
    $cLevel--;
  }


  function prefixElements($array, $prefix) {
    //if (!is_array($this->haystack)) { $this->haystack = array(); }
    //array_walk($this->haystack, array($this, 'prefixElements_walker'), $prefix);
    //array_walk($array, array($this, 'prefixElements_walker'), $prefix);
    array_walk($array, 'prefixElements_walker', $prefix);
    return $array;
  }


  function buildSymmetricIntegerHash($begin, $end) {
    $res = array();
    if(!$begin || !is_int($begin) || !$end || !is_int($end)) { 
      $res[0] = "Error: Function 'buildSymmetricIntegerHash' can only used with Integer as Variable Type!";
      return $res;
    }
    $diff = $end - $begin;
    if($diff<=0) {
      $res[0] = "Error: Var 'end' in Function 'buildSymmetricIntegerHash' is smaller or eqal asVar 'begin' !";
      return $res;
    }
    $this->haystack = array();
    for ($i=$begin;$i<=$end;$i++) {
      $this->haystack[$i] = $i;
    }
    return $this->haystack;
  }


}

?>